//
//  View.m
//  Frames
//
//  Created by NYU User on 11/9/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"


@implementation View


- (id) initWithFrame: (CGRect)frame {
	if ((self = [super initWithFrame:frame]) != nil) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];
		
		//Create the layer.
		
		UIImage *image = [UIImage imageNamed: @"0.png"];
		if (image == nil) {
			NSLog(@"could not get 0.png");
			[self release];
			return nil;
		}

		layer = [[CALayer alloc] init];
		CGSize size = image.size;
		layer.frame = CGRectMake(
			(self.bounds.size.width - size.width) / 2,
			(self.bounds.size.height - size.height) / 2,
			size.width,
			size.height
		);
		layer.contents = (id)[image CGImage];
		[self.layer addSublayer: layer];
		
		//Create the animation.
		
		animation =
			[CAKeyframeAnimation animationWithKeyPath: @"contents"];
		animation.duration = 4;
		animation.repeatCount = HUGE_VALF;	//repeat forever

		NSUInteger n = 8;	//number of images
		NSMutableArray *a = [NSMutableArray arrayWithCapacity: n];
		
		for (int i = 0; i < n; ++i) {
			NSString *name = [NSString stringWithFormat: @"%d.png", i];
			UIImage *image = [UIImage imageNamed: name];
			if (image == nil) {
				NSLog(@"could not get image %@", name);
				continue;
			}
			[a addObject: (id)[image CGImage]];
		}
		
		animation.values = a;
		[animation retain];
	}
	return self;
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
	// Drawing code
	[layer addAnimation: animation forKey: @"flipBook"];
}


- (void) dealloc {
	[layer removeAnimationForKey: @"flipBook"];	//just to demonstrate
	[animation release];
	[layer release];
	[super dealloc];
}


@end
